<template>
    <div>
        <v-row>
            <v-col v-for="(image, index) in images" :key="index" class="d-flex child-flex" cols="4">
                <v-img @click="() => { openCropper(index) }" :src="image.path" aspect-ratio="1" width="150"
                    class="grey lighten-2">
                    <template v-slot:placeholder>
                        <v-row class="fill-height ma-0" align="center" justify="center">
                            <v-progress-circular indeterminate color="grey lighten-5"></v-progress-circular>
                        </v-row>
                    </template>
                </v-img>
            </v-col>
        </v-row>
        <div id="cropper-wrapper" v-if="cropperOpened">
            <vue-cropper style="max-height: 80vh; width: auto" ref="cropper" :src="srcs[selectedIndex]"
                alt="Kadrowany obraz" @ready="() => { }" @cropend="cropend"></vue-cropper>
            <div class="buttons-wrapper">
                <v-btn dark @click="cropIt">
                Zapisz
            </v-btn>
            <v-btn dark @click="cancel">
                Anuluj
            </v-btn>
        </div>
        </div>
    </div>
</template>
<script>
import vueCropper from 'vue-cropperjs'

export default {
    name: 'ImageManipulation',
    components: { vueCropper },
    props: {
        images: {
            type: Array
        },
    },

    data() {
        return {
            galleryOpened: null,
            cropperOpened: false,
            selectedIndex: -1,
            files: [],
            srcs: [],
            data: null
        }
    },

    async beforeMount() {
        this.galleryOpened = this.images.length > 0;
    },

    methods: {
        async openCropper(index) {
            this.selectedIndex = index;
            this.$axios.post(this.$config.serverUrl+'/image/to-blob',
            {imageBase64: this.images[index]}).then(({data})=>{
                this.cropperOpened = true;
                this.srcs[index] = this.$config.serverUrl + '/images/' + data.name;
                this.$forceUpdate();
            })
        },

        async cropIt(data) {
            this.images[this.selectedIndex] = {path: this.$refs.cropper.getCroppedCanvas().toDataURL()};
            this.cropperOpened = false;
            this.$emit('cropped',{index: this.selectedIndex, path: this.images[this.selectedIndex].path});
        },
        cancel() {
            this.cropperOpened = false;
        },
        cropend(data) {            
        }
    }
}
</script>
<style scoped lang="scss">
#cropper-wrapper {
    position: absolute;
    top: 0px;
    z-index: 9999;
    display: flex;
    flex-direction: column;
    justify-content: center;
    .buttons-wrapper {
        display: flex;
        flex-direction: row;
        justify-content: space-evenly;
    }
}

</style>